﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_letter_combinations2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Generate the words.
        private void btnGo_Click(object sender, EventArgs e)
        {
            // If this will take a long time, make the user confirm.
            if (nudNumLetters.Value > 3)
            {
                if (MessageBox.Show("This will generate " +
                    Math.Pow(26, (double)nudNumLetters.Value) +
                    " strings. Are you aure you want to do this?",
                    "Are You Sure?",
                    MessageBoxButtons.YesNo,
                    MessageBoxIcon.Question) != DialogResult.Yes)
                    return;
            }

            Cursor = Cursors.WaitCursor;
            lstCombinations.DataSource = null;
            lblCombinations.Text = "";
            Refresh();

            // Generate the combinations.
            lstCombinations.DataSource =
                GenerateLetterCombinations((int)nudNumLetters.Value);
            lblCombinations.Text =
                lstCombinations.Items.Count.ToString("#,#") + " combinations";

            Cursor = Cursors.Default;
        }

        // Generate words with num_letters letters.
        private List<string> GenerateLetterCombinations(int num_letters)
        {
            List<string> values = new List<string>();

            // Build one-letter combinations.
            for (char ch = 'a'; ch <= 'z'; ch++)
            {
                values.Add(ch.ToString());
            }

            // Add onto the combinations.
            for (int i = 1; i < num_letters; i++)
            {
                // Make combinations containing i + 1 letters.
                List<string> new_values = new List<string>();
                foreach (string str in values)
                {
                    // Add all possible letters to this string.
                    for (char ch = 'a'; ch <= 'z'; ch++)
                    {
                        new_values.Add(str + ch);
                    }
                }

                // Replace the old values with the new ones.
                values = new_values;
            }

            return values;
        }
    }
}
